clc
clear

% parallel setting
%Due to huge amount of computation, it is wise to use 
%more than 50 opretors for parallel computing

% load data
load data01

options = zeros(1,2);
options(1) = 1000;
options(2) = 1e-6;
    
paratemp = zeros(length(Ndata),niter);
paratemp1 = paratemp;
paratemp2 = zeros(length(Lamd),niter);
paratemp3 = paratemp2;

% lambda = 5
lam0 = 5;
mix0.lam = lam0;
  for i = 1:length(Ndata)   
      
    parfor j=1:niter
    %random sample
    data1 = datamat1{j,i};

    % compute two PMLE
    [pLogl, pMix, pNit, pLld] = plmesnm1(data1, mix0, options);
    paratemp(i,j) = pMix.lam;
    [pLogl1, pMix1, pNit1, pLld1] = plmesnm2(data1, mix0, options);
    paratemp1(i,j) = pMix1.lam;

    end
  end

 

% n = 100
ndata = 100;
  for k = 1:length(Lamd) 
      mix0.lam = Lamd(k);
     
    parfor m=1:niter
    %random sample
    data2 = datamat2{m,k};

    % compute two PMLE
    [pLogl2, pMix2, pNit2, pLld2] = plmesnm1(data2, mix0, options);
    paratemp2(k,m) = pMix2.lam;
    [pLogl3, pMix3, pNit3, pLld3] = plmesnm2(data2, mix0, options);
    paratemp3(k,m) = pMix3.lam;

    end
  end
  
  
% results
bias = mean(bsxfun(@minus,paratemp,lam0),2);
sd = sqrt(mean(bsxfun(@minus,paratemp,lam0).^2,2));
bias1 = mean(bsxfun(@minus,paratemp1,lam0),2);
sd1 = sqrt(mean(bsxfun(@minus,paratemp1,lam0).^2,2));
bias2 = mean(bsxfun(@minus,paratemp2, Lamd'),2);
sd2 = sqrt(mean(bsxfun(@minus,paratemp2,  Lamd').^2,2));
bias3 = mean(bsxfun(@minus,paratemp3, Lamd'),2);
sd3 = sqrt(mean(bsxfun(@minus,paratemp3, Lamd').^2,2));
tabl1 = log(abs([bias sd bias1 sd1]));
tabl2 = log(abs([bias2 sd2 bias3 sd3]));

save res01


% Draw pictures
figure
subplot(2,2,1)
plot(log(Ndata),log(abs(bias)),'g*-')
hold on
plot(log(Ndata),log(abs(bias1)),'bo-')
ylabel('log(|bias|)')
xlabel('log(n)')
legend('PMLE','MPLE')
axis([3.7 7.2 -3.5 0.6])
subplot(2,2,2)
plot(log(Ndata),log(sd),'g*-')
hold on
plot(log(Ndata),log(sd1),'bo-')
ylabel('log(RMSE)')
xlabel('log(n)')
axis([3.7 7.2 -0.8 1.2])

subplot(2,2,3)
plot(Lamd,log(abs(bias2)),'g*-')
hold on
plot(Lamd,log(abs(bias3)),'bo-')
ylabel('log(|bias|)')
xlabel('\lambda')
axis([0.5 10.5 -3.5 0.9])
subplot(2,2,4)
plot(Lamd,log(sd2),'g*-')
hold on
plot(Lamd,log(sd3),'bo-')
ylabel('log(RMSE)')
xlabel('\lambda')
axis([0.5 10.5 -0.4 1.6])




