function [Logl, Mix, Nit, Lld] = gmmem(data, mix, options)
% compute MLE of normal mixtures with EM
% data is 1*N vector;
% mix is the structure variable contains 
%    mix.order: order of mixtures K
%    mix.pi: mixing proportions K*1
%    mix.mu: locations vector K*1
%    mix.sig: scale vector K*1
% options(1) = iterating times bound
% options(2) = error tlerance rate
% Logl is log-likelihood;
% Nit is iterating times;
% Lld is a vector of all log-likelihood .


% basic 
Lld = zeros(1,options(1));
logLold = gmmlog(data, mix);
newmix.order = mix.order;

err=1;
n=1;
% Main loop
while (n<=options(1) && err>options(2))
%n
     % E step
     Post = gmmpost(data, mix);
     
     % M step
     newmix.pi = sum(Post,2)./size(data,2);
     newmix.mu = Post*data'./sum(Post,2);
     newmix.sig = sum(Post.*bsxfun(@minus, data, newmix.mu).^2,2)./sum(Post,2);

     % update variable
     logLnew = gmmlog(data, newmix);
     err = abs((logLnew-logLold)/logLold);
     logLold = logLnew;
     Lld(n) = logLnew;
     mix = newmix;
     n = n + 1;
         
end

Logl = logLnew;
Mix = newmix;
Nit = n-1;
if Nit < options(1)
   Lld(n : options(1))=[];
end

     
