function Logl = gmmlog(data, mix)
% compute log-likelihood of normal mixtures
% data is 1*n vector

Temp = bsxfun(@rdivide, bsxfun(@minus, data, mix.mu).^2, mix.sig+realmin);
Temp1 = bsxfun(@plus, -0.5.*Temp, log(mix.pi+realmin)-0.5.*log(mix.sig+realmin));
maxt = max(Temp1,[],1);
post = exp(bsxfun(@minus, Temp1, maxt));
Logl = size(data,2)*log(2*pi)/2 + sum(log(sum(post,1)) + maxt, 2);



