function mix = initsn(data, K)
% initialize the parameters of sn mixtures;
% data is 1*N vector;
% K is the mixture order;

mix.order = K;

% with K-means
options = zeros(1, 18);
options(5) = 1;	
options(14) = 5;
[centres, options, post] = kmeans(data', K, options);
while rank(post)<K
    [centres, options, post] = kmeans(data', K, options);
end
mix.pi = sum(post,1)'./size(data,2);

a1 = sqrt(2/pi);
b1 = (4/pi-1)*a1;
m2 = zeros(K,1);
m3 = m2;
for i=1:K
    mt = data(post(:,i)==1)-centres(i);
    nt = sum(post(:,i),1);
    m2(i,1) = sum(mt.^2,2)/nt;
    m3(i,1) = sum(mt.^3,2)/nt;
end

% initialize with moment estimator
delta = (a1^2+m2.*(b1./abs(m3)).^(2/3)).^(-0.5).*sign(m3);
temp = (1-1e-3).*ones(K,1);
delta = min(delta,temp);
delta = max(delta,-temp);
mix.lam = delta./sqrt(1-delta.^2); 

mix.sig = m2 ./(1-2/pi.*delta.^2);
mix.mu = centres - a1.*sqrt(mix.sig).*delta;
% mix.mu = centres-a1.*(abs(m3)./b1).^(1/3).*sign(m3);
% mix.sig = m2 + a1^2.*(abs(m3)./b1).^(2/3);





